Index: uspace/lib/c/include/io/pos_event.h
===================================================================
--- uspace/lib/c/include/io/pos_event.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
+++ uspace/lib/c/include/io/pos_event.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_POS_EVENT_H_
+#define LIBC_IO_POS_EVENT_H_
+
+#include <sys/types.h>
+
+typedef enum {
+	POS_UPDATE,
+	POS_PRESS,
+	POS_RELEASE
+} pos_event_type_t;
+
+/** Positioning device event */
+typedef struct {
+	sysarg_t pos_id;
+	pos_event_type_t type;
+	sysarg_t btn_num;
+	sysarg_t hpos;
+	sysarg_t vpos;
+} pos_event_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/io/window.h
===================================================================
--- uspace/lib/c/include/io/window.h	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/c/include/io/window.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -40,19 +40,6 @@
 #include <async.h>
 #include <loc.h>
-#include <io/console.h>
-
-typedef enum {
-	POS_UPDATE,
-	POS_PRESS,
-	POS_RELEASE
-} pos_event_type_t;
-
-typedef struct {
-	sysarg_t pos_id;
-	pos_event_type_t type;
-	sysarg_t btn_num;
-	sysarg_t hpos;
-	sysarg_t vpos;
-} pos_event_t;
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
 
 typedef struct {
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/clui/tinput.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -45,4 +45,5 @@
 #define LIN_TO_COL(ti, lpos) ((lpos) % ((ti)->con_cols))
 #define LIN_TO_ROW(ti, lpos) ((lpos) / ((ti)->con_cols))
+#define LIN_POS(ti, col, row) ((col) + (row) * (ti)->con_cols)
 
 /** Seek direction */
@@ -383,4 +384,21 @@
 }
 
+static void tinput_seek_scrpos(tinput_t *ti, int col, int line, bool shift_held)
+{
+	unsigned lpos;
+	tinput_pre_seek(ti, shift_held);
+
+	lpos = LIN_POS(ti, col, line);
+
+	if (lpos > ti->text_coord)
+		ti->pos = lpos -  ti->text_coord;
+	else
+		ti->pos = 0;
+	if (ti->pos > ti->nc)
+		ti->pos = ti->nc;
+
+	tinput_post_seek(ti, shift_held);
+}
+
 static void tinput_seek_max(tinput_t *ti, seek_dir_t dir, bool shift_held)
 {
@@ -787,4 +805,52 @@
 }
 
+/** Handle key press event. */
+static void tinput_key_press(tinput_t *ti, kbd_event_t *kev)
+{
+	if (kev->key == KC_LSHIFT)
+		ti->lshift_held = true;
+	if (kev->key == KC_RSHIFT)
+		ti->rshift_held = true;
+
+	if (((kev->mods & KM_CTRL) != 0) &&
+	    ((kev->mods & (KM_ALT | KM_SHIFT)) == 0))
+		tinput_key_ctrl(ti, kev);
+	
+	if (((kev->mods & KM_SHIFT) != 0) &&
+	    ((kev->mods & (KM_CTRL | KM_ALT)) == 0))
+		tinput_key_shift(ti, kev);
+	
+	if (((kev->mods & KM_CTRL) != 0) &&
+	    ((kev->mods & KM_SHIFT) != 0) &&
+	    ((kev->mods & KM_ALT) == 0))
+		tinput_key_ctrl_shift(ti, kev);
+	
+	if ((kev->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
+		tinput_key_unmod(ti, kev);
+	
+	if (kev->c >= ' ') {
+		tinput_sel_delete(ti);
+		tinput_insert_char(ti, kev->c);
+	}
+}
+
+/** Handle key release event. */
+static void tinput_key_release(tinput_t *ti, kbd_event_t *kev)
+{
+	if (kev->key == KC_LSHIFT)
+		ti->lshift_held = false;
+	if (kev->key == KC_RSHIFT)
+		ti->rshift_held = false;
+}
+
+/** Position event */
+static void tinput_pos(tinput_t *ti, pos_event_t *ev)
+{
+	if (ev->type == POS_PRESS) {
+		tinput_seek_scrpos(ti, ev->hpos, ev->vpos,
+		    ti->lshift_held || ti->rshift_held);
+	}
+}
+
 /** Read in one line of input.
  *
@@ -816,30 +882,18 @@
 		console_flush(ti->console);
 		
-		kbd_event_t ev;
-		if (!console_get_kbd_event(ti->console, &ev))
+		cons_event_t ev;
+		if (!console_get_event(ti->console, &ev))
 			return EIO;
 		
-		if (ev.type != KEY_PRESS)
-			continue;
-		
-		if (((ev.mods & KM_CTRL) != 0) &&
-		    ((ev.mods & (KM_ALT | KM_SHIFT)) == 0))
-			tinput_key_ctrl(ti, &ev);
-		
-		if (((ev.mods & KM_SHIFT) != 0) &&
-		    ((ev.mods & (KM_CTRL | KM_ALT)) == 0))
-			tinput_key_shift(ti, &ev);
-		
-		if (((ev.mods & KM_CTRL) != 0) &&
-		    ((ev.mods & KM_SHIFT) != 0) &&
-		    ((ev.mods & KM_ALT) == 0))
-			tinput_key_ctrl_shift(ti, &ev);
-		
-		if ((ev.mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
-			tinput_key_unmod(ti, &ev);
-		
-		if (ev.c >= ' ') {
-			tinput_sel_delete(ti);
-			tinput_insert_char(ti, ev.c);
+		switch (ev.type) {
+		case CEV_KEY:
+			if (ev.ev.key.type == KEY_PRESS)
+				tinput_key_press(ti, &ev.ev.key);
+			else
+				tinput_key_release(ti, &ev.ev.key);
+			break;
+		case CEV_POS:
+			tinput_pos(ti, &ev.ev.pos);
+			break;
 		}
 	}
Index: uspace/lib/clui/tinput.h
===================================================================
--- uspace/lib/clui/tinput.h	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/clui/tinput.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -146,4 +146,10 @@
 	/** @c true if user requested to abort interactive loop */
 	bool exit_clui;
+
+	/** @c true if left shift key is currently held */
+	bool lshift_held;
+
+	/** @c true if right shift key is currently held */
+	bool rshift_held;
 } tinput_t;
 
Index: uspace/lib/gui/Makefile
===================================================================
--- uspace/lib/gui/Makefile	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/gui/Makefile	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -35,4 +35,5 @@
 SOURCES = \
 	button.c \
+	canvas.c \
 	connection.c \
 	grid.c \
Index: uspace/lib/gui/canvas.c
===================================================================
--- uspace/lib/gui/canvas.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
+++ uspace/lib/gui/canvas.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -0,0 +1,159 @@
+/*
+ * Copyright (c) 2013 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <malloc.h>
+#include <transform.h>
+#include <source.h>
+#include <surface.h>
+#include <drawctx.h>
+#include "window.h"
+#include "canvas.h"
+
+static void paint_internal(widget_t *widget)
+{
+	canvas_t *canvas = (canvas_t *) widget;
+	
+	surface_t *surface = window_claim(canvas->widget.window);
+	if (!surface) {
+		window_yield(canvas->widget.window);
+	}
+	
+	transform_t transform;
+	transform_identity(&transform);
+	transform_translate(&transform, widget->hpos, widget->vpos);
+	
+	source_t source;
+	source_init(&source);
+	source_set_transform(&source, transform);
+	source_set_texture(&source, canvas->surface, false);
+	
+	drawctx_t drawctx;
+	drawctx_init(&drawctx, surface);
+	
+	drawctx_set_source(&drawctx, &source);
+	drawctx_transfer(&drawctx, widget->hpos, widget->vpos, widget->width,
+	    widget->height);
+	
+	window_yield(canvas->widget.window);
+}
+
+void deinit_canvas(canvas_t *canvas)
+{
+	widget_deinit(&canvas->widget);
+}
+
+static void canvas_destroy(widget_t *widget)
+{
+	canvas_t *canvas = (canvas_t *) widget;
+	
+	deinit_canvas(canvas);
+	free(canvas);
+}
+
+static void canvas_reconfigure(widget_t *widget)
+{
+	/* No-op */
+}
+
+static void canvas_rearrange(widget_t *widget, sysarg_t hpos, sysarg_t vpos,
+    sysarg_t width, sysarg_t height)
+{
+	canvas_t *canvas = (canvas_t *) widget;
+	
+	widget_modify(widget, hpos, vpos, canvas->width, canvas->height);
+	paint_internal(widget);
+}
+
+static void canvas_repaint(widget_t *widget)
+{
+	paint_internal(widget);
+	window_damage(widget->window);
+}
+
+static void canvas_handle_keyboard_event(widget_t *widget, kbd_event_t event)
+{
+	/* No-op */
+}
+
+static void canvas_handle_position_event(widget_t *widget, pos_event_t event)
+{
+	/* No-op */
+}
+
+bool init_canvas(canvas_t *canvas, widget_t *parent, sysarg_t width,
+    sysarg_t height, surface_t *surface)
+{
+	widget_init(&canvas->widget, parent);
+	
+	canvas->widget.width = width;
+	canvas->widget.height = height;
+	
+	canvas->widget.width_min = width;
+	canvas->widget.height_min = height;
+	canvas->widget.width_ideal = width;
+	canvas->widget.height_ideal = height;
+	canvas->widget.width_max = width;
+	canvas->widget.height_max = height;
+	
+	canvas->widget.destroy = canvas_destroy;
+	canvas->widget.reconfigure = canvas_reconfigure;
+	canvas->widget.rearrange = canvas_rearrange;
+	canvas->widget.repaint = canvas_repaint;
+	canvas->widget.handle_keyboard_event = canvas_handle_keyboard_event;
+	canvas->widget.handle_position_event = canvas_handle_position_event;
+	
+	canvas->width = width;
+	canvas->height = height;
+	canvas->surface = surface;
+	
+	return true;
+}
+
+canvas_t *create_canvas(widget_t *parent, sysarg_t width, sysarg_t height,
+    surface_t *surface)
+{
+	canvas_t *canvas = (canvas_t *) malloc(sizeof(canvas_t));
+	if (!canvas)
+		return NULL;
+	
+	if (init_canvas(canvas, parent, width, height, surface))
+		return canvas;
+	
+	free(canvas);
+	return NULL;
+}
+
+/** @}
+ */
Index: uspace/lib/gui/canvas.h
===================================================================
--- uspace/lib/gui/canvas.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
+++ uspace/lib/gui/canvas.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2013 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_CANVAS_H_
+#define GUI_CANVAS_H_
+
+#include <stdbool.h>
+#include <sys/types.h>
+#include <io/pixel.h>
+#include <surface.h>
+#include "widget.h"
+
+typedef struct {
+	widget_t widget;
+	sysarg_t width;
+	sysarg_t height;
+	surface_t *surface;
+} canvas_t;
+
+extern bool init_canvas(canvas_t *, widget_t *, sysarg_t, sysarg_t,
+    surface_t *);
+extern canvas_t *create_canvas(widget_t *, sysarg_t, sysarg_t, surface_t *);
+extern void deinit_canvas(canvas_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gui/grid.c
===================================================================
--- uspace/lib/gui/grid.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/gui/grid.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2012 Petr Koupy
+ * Copyright (c) 2013 Martin Decky
  * All rights reserved.
  *
@@ -38,33 +39,58 @@
 #include <malloc.h>
 #include <surface.h>
-
 #include "window.h"
 #include "grid.h"
 
-static void paint_internal(widget_t *w)
-{
-	grid_t *grid = (grid_t *) w;
-
+typedef struct {
+	sysarg_t min;
+	sysarg_t max;
+	sysarg_t val;
+} constraints_t;
+
+static void paint_internal(widget_t *widget)
+{
+	grid_t *grid = (grid_t *) widget;
+	
 	surface_t *surface = window_claim(grid->widget.window);
 	if (!surface) {
 		window_yield(grid->widget.window);
-	}
-
-	for (sysarg_t y = w->vpos; y <  w->vpos + w->height; ++y) {
-		for (sysarg_t x = w->hpos; x < w->hpos + w->width; ++x) {
+		return;
+	}
+	
+	// FIXME: Replace with (accelerated) rectangle fill
+	for (sysarg_t y = widget->vpos; y < widget->vpos + widget->height; y++) {
+		for (sysarg_t x = widget->hpos; x < widget->hpos + widget->width; x++)
 			surface_put_pixel(surface, x, y, grid->background);
-		}
-	}
-
+	}
+	
 	window_yield(grid->widget.window);
 }
 
-static widget_t **widget_at(grid_t *grid, size_t row, size_t col)
-{
-	if (row < grid->rows && col < grid->cols) {
+static grid_cell_t *grid_cell_at(grid_t *grid, size_t col, size_t row)
+{
+	if ((col < grid->cols) && (row < grid->rows))
 		return grid->layout + (row * grid->cols + col);
-	} else {
-		return NULL;
-	}
+	
+	return NULL;
+}
+
+static grid_cell_t *grid_coords_at(grid_t *grid, sysarg_t hpos, sysarg_t vpos)
+{
+	for (size_t c = 0; c < grid->cols; c++) {
+		for (size_t r = 0; r < grid->rows; r++) {
+			grid_cell_t *cell = grid_cell_at(grid, c, r);
+			if (cell) {
+				widget_t *widget = cell->widget;
+				
+				if ((widget) && (hpos >= widget->hpos) &&
+				    (vpos >= widget->vpos) &&
+				    (hpos < widget->hpos + widget->width) &&
+				    (vpos < widget->vpos + widget->height))
+					return cell;
+			}
+		}
+	}
+	
+	return NULL;
 }
 
@@ -78,7 +104,6 @@
 {
 	grid_t *grid = (grid_t *) widget;
-
+	
 	deinit_grid(grid);
-
 	free(grid);
 }
@@ -86,5 +111,69 @@
 static void grid_reconfigure(widget_t *widget)
 {
-	/* no-op */
+	/* No-op */
+}
+
+static void adjust_constraints(constraints_t *cons, size_t run,
+    sysarg_t dim_min, sysarg_t dim_max)
+{
+	assert(run > 0);
+	
+	sysarg_t dim_min_part = dim_min / run;
+	sysarg_t dim_min_rem = dim_min % run;
+	
+	sysarg_t dim_max_part = dim_max / run;
+	sysarg_t dim_max_rem = dim_max % run;
+	
+	for (size_t i = 0; i < run; i++) {
+		sysarg_t dim_min_cur = dim_min_part;
+		sysarg_t dim_max_cur = dim_max_part;
+		
+		if (i == run - 1) {
+			dim_min_cur += dim_min_rem;
+			dim_max_cur += dim_max_rem;
+		}
+		
+		/*
+		 * We want the strongest constraint
+		 * for the minimum.
+		 */
+		if (cons[i].min < dim_min_cur)
+			cons[i].min = dim_min_cur;
+		
+		/*
+		 * The comparison is correct, we want
+		 * the weakest constraint for the
+		 * maximum.
+		 */
+		if (cons[i].max < dim_max_cur)
+			cons[i].max = dim_max_cur;
+	}
+}
+
+static void solve_constraints(constraints_t *cons, size_t run, sysarg_t sum)
+{
+	/* Initial solution */
+	sysarg_t cur_sum = 0;
+	
+	for (size_t i = 0; i < run; i++) {
+		cons[i].val = cons[i].min;
+		cur_sum += cons[i].val;
+	}
+	
+	/* Iterative improvement */
+	while (cur_sum < sum) {
+		sysarg_t delta = (sum - cur_sum) / run;
+		if (delta == 0)
+			break;
+		
+		cur_sum = 0;
+		
+		for (size_t i = 0; i < run; i++) {
+			if (cons[i].val + delta < cons[i].max)
+				cons[i].val += delta;
+			
+			cur_sum += cons[i].val;
+		}
+	}
 }
 
@@ -93,61 +182,114 @@
 {
 	grid_t *grid = (grid_t *) widget;
-
+	
 	widget_modify(widget, hpos, vpos, width, height);
 	paint_internal(widget);
-
-	sysarg_t cell_width = width / grid->cols;
-	sysarg_t cell_height = height / grid->rows;
-
-	list_foreach(widget->children, link) {
-		widget_t *child = list_get_instance(link, widget_t, link);
-
-		sysarg_t widget_hpos = 0;
-		sysarg_t widget_vpos = 0;
-		sysarg_t widget_width = 0;
-		sysarg_t widget_height = 0;
-
-		size_t r = 0;
-		size_t c = 0;
-		for (r = 0; r < grid->rows; ++r) {
-			bool found = false;
-			for (c = 0; c < grid->cols; ++c) {
-				widget_t **cell = widget_at(grid, r, c);
-				if (cell && *cell == child) {
-					found = true;
-					break;
+	
+	/* Compute column widths */
+	constraints_t *widths =
+	    (constraints_t *) calloc(grid->cols, sizeof(constraints_t));
+	if (widths) {
+		/* Constrain widths */
+		for (size_t c = 0; c < grid->cols; c++) {
+			widths[c].min = 0;
+			
+			for (size_t r = 0; r < grid->rows; r++) {
+				grid_cell_t *cell = grid_cell_at(grid, c, r);
+				if (!cell)
+					continue;
+				
+				widget_t *widget = cell->widget;
+				if (widget)
+					adjust_constraints(&widths[c], cell->cols,
+					    widget->width_min, widget->width_max);
+			}
+		}
+		
+		solve_constraints(widths, grid->cols, width);
+	}
+	
+	/* Compute row heights */
+	constraints_t *heights =
+	    (constraints_t *) calloc(grid->rows, sizeof(constraints_t));
+	if (heights) {
+		/* Constrain heights */
+		for (size_t r = 0; r < grid->rows; r++) {
+			heights[r].min = 0;
+			
+			for (size_t c = 0; c < grid->cols; c++) {
+				grid_cell_t *cell = grid_cell_at(grid, c, r);
+				if (!cell)
+					continue;
+				
+				widget_t *widget = cell->widget;
+				if (widget) {
+					adjust_constraints(&heights[r], cell->rows,
+					    widget->height_min, widget->height_max);
 				}
 			}
-			if (found) {
-				break;
+		}
+		
+		solve_constraints(heights, grid->rows, height);
+	}
+	
+	/* Rearrange widgets */
+	if ((widths) && (heights)) {
+		sysarg_t cur_vpos = vpos;
+		
+		for (size_t r = 0; r < grid->rows; r++) {
+			sysarg_t cur_hpos = hpos;
+			
+			for (size_t c = 0; c < grid->cols; c++) {
+				grid_cell_t *cell = grid_cell_at(grid, c, r);
+				if (!cell)
+					continue;
+				
+				widget_t *widget = cell->widget;
+				if (widget) {
+					sysarg_t cur_width = 0;
+					sysarg_t cur_height = 0;
+					
+					for (size_t cd = 0; cd < cell->cols; cd++)
+						cur_width += widths[c + cd].val;
+					
+					for (size_t rd = 0; rd < cell->rows; rd++)
+						cur_height += heights[r + rd].val;
+					
+					if ((cur_width > 0) && (cur_height > 0)) {
+						sysarg_t wwidth = cur_width;
+						sysarg_t wheight = cur_height;
+						
+						/*
+						 * Make sure the widget is respects its
+						 * maximal constrains.
+						 */
+						
+						if ((widget->width_max > 0) &&
+						    (wwidth > widget->width_max))
+							wwidth = widget->width_max;
+						
+						if ((widget->height_max > 0) &&
+						    (wheight > widget->height_max))
+							wheight = widget->height_max;
+						
+						widget->rearrange(widget, cur_hpos, cur_vpos,
+						    wwidth, wheight);
+					}
+					
+					
+				}
+				
+				cur_hpos += widths[c].val;
 			}
-		}
-
-		widget_hpos = cell_width * c + hpos;
-		widget_vpos = cell_height * r + vpos;
-
-		for (size_t _c = c; _c < grid->cols; ++_c) {
-			widget_t **cell = widget_at(grid, r, _c);
-			if (cell && *cell == child) {
-				widget_width += cell_width;
-			} else {
-				break;
-			}
-		}
-
-		for (size_t _r = r; _r < grid->rows; ++_r) {
-			widget_t **cell = widget_at(grid, _r, c);
-			if (cell && *cell == child) {
-				widget_height += cell_height;
-			} else {
-				break;
-			}
-		}
-
-		if (widget_width > 0 && widget_height > 0) {
-			child->rearrange(child,
-			    widget_hpos, widget_vpos, widget_width, widget_height);
-		}
-	}
+			
+			cur_vpos += heights[r].val;
+		}
+	}
+	
+	if (widths)
+		free(widths);
+	
+	if (heights)
+		free(heights);
 }
 
@@ -155,8 +297,10 @@
 {
 	paint_internal(widget);
+	
 	list_foreach(widget->children, link) {
 		widget_t *child = list_get_instance(link, widget_t, link);
 		child->repaint(child);
 	}
+	
 	window_damage(widget->window);
 }
@@ -164,5 +308,5 @@
 static void grid_handle_keyboard_event(widget_t *widget, kbd_event_t event)
 {
-	/* no-op */
+	/* No-op */
 }
 
@@ -170,55 +314,69 @@
 {
 	grid_t *grid = (grid_t *) widget;
-
-	if ((widget->height / grid->rows) == 0) {
-		return;
-	}
-	if ((widget->width / grid->cols) == 0) {
-		return;
-	}
-
-	sysarg_t row = (event.vpos - widget->vpos) / (widget->height / grid->rows);
-	sysarg_t col = (event.hpos - widget->hpos) / (widget->width / grid->cols);
-
-	widget_t **cell = widget_at(grid, row, col);
-	if (cell && *cell) {
-		(*cell)->handle_position_event(*cell, event);
-	}
-}
-
-static void grid_add(grid_t *grid, widget_t *widget,
-    size_t row, size_t col, size_t rows, size_t cols)
-{
-	assert(row + rows <= grid->rows);
-	assert(col + cols <= grid->cols);
-
+	
+	grid_cell_t *cell = grid_coords_at(grid, event.hpos, event.vpos);
+	if ((cell) && (cell->widget))
+		cell->widget->handle_position_event(cell->widget, event);
+}
+
+static bool grid_add(struct grid *grid, widget_t *widget, size_t col,
+    size_t row, size_t cols, size_t rows)
+{
+	if ((cols == 0) || (rows == 0) || (col + cols > grid->cols) ||
+	    (row + rows > grid->rows))
+		return false;
+	
+	grid_cell_t *cell = grid_cell_at(grid, col, row);
+	if (!cell)
+		return false;
+	
+	/*
+	 * Check whether the cell is not occupied by an
+	 * extension of a different cell.
+	 */
+	if ((!cell->widget) && (cell->cols > 0) && (cell->rows > 0))
+		return false;
+	
 	widget->parent = (widget_t *) grid;
+	
 	list_append(&widget->link, &grid->widget.children);
 	widget->window = grid->widget.window;
-
-	for (size_t r = row; r < row + rows; ++r) {
-		for (size_t c = col; c < col + cols; ++c) {
-			widget_t **cell = widget_at(grid, r, c);
-			if (cell) {
-				*cell = widget;
+	
+	/* Mark cells in layout */
+	for (size_t r = row; r < row + rows; r++) {
+		for (size_t c = col; c < col + cols; c++) {
+			if ((r == row) && (c == col)) {
+				cell->widget = widget;
+				cell->cols = cols;
+				cell->rows = rows;
+			} else {
+				grid_cell_t *extension = grid_cell_at(grid, c, r);
+				if (extension) {
+					extension->widget = NULL;
+					extension->cols = 1;
+					extension->rows = 1;
+				}
 			}
 		}
 	}
-}
-
-bool init_grid(grid_t *grid,
-    widget_t *parent, size_t rows, size_t cols, pixel_t background)
-{
-	assert(rows > 0);
-	assert(cols > 0);
-
-	widget_t **layout = (widget_t **) malloc(rows * cols * sizeof(widget_t *));
-	if (!layout) {
+	
+	return true;
+}
+
+bool init_grid(grid_t *grid, widget_t *parent, size_t cols, size_t rows,
+    pixel_t background)
+{
+	if ((cols == 0) || (rows == 0))
 		return false;
-	}
-	memset(layout, 0, rows * cols * sizeof(widget_t *));
-
+	
+	grid->layout =
+	    (grid_cell_t *) calloc(cols * rows, sizeof(grid_cell_t));
+	if (!grid->layout)
+		return false;
+	
+	memset(grid->layout, 0, cols * rows * sizeof(grid_cell_t));
+	
 	widget_init(&grid->widget, parent);
-
+	
 	grid->widget.destroy = grid_destroy;
 	grid->widget.reconfigure = grid_reconfigure;
@@ -227,27 +385,24 @@
 	grid->widget.handle_keyboard_event = grid_handle_keyboard_event;
 	grid->widget.handle_position_event = grid_handle_position_event;
-
+	
 	grid->add = grid_add;
 	grid->background = background;
+	grid->cols = cols;
 	grid->rows = rows;
-	grid->cols = cols;
-	grid->layout = layout;
-
+	
 	return true;
 }
 
-grid_t *create_grid(widget_t *parent, size_t rows, size_t cols, pixel_t background)
+grid_t *create_grid(widget_t *parent, size_t cols, size_t rows, pixel_t background)
 {
 	grid_t *grid = (grid_t *) malloc(sizeof(grid_t));
-	if (!grid) {
+	if (!grid)
 		return NULL;
-	}
-
-	if (init_grid(grid, parent, rows, cols, background)) {
+	
+	if (init_grid(grid, parent, cols, rows, background))
 		return grid;
-	} else {
-		free(grid);
-		return NULL;
-	}
+	
+	free(grid);
+	return NULL;
 }
 
Index: uspace/lib/gui/grid.h
===================================================================
--- uspace/lib/gui/grid.h	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/gui/grid.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -39,17 +39,19 @@
 #include <sys/types.h>
 #include <io/pixel.h>
-
 #include "widget.h"
 
-struct grid;
-typedef struct grid grid_t;
+typedef struct {
+	widget_t *widget;
+	size_t cols;
+	size_t rows;
+} grid_cell_t;
 
 typedef struct grid {
 	widget_t widget;
 	pixel_t background;
+	size_t cols;
 	size_t rows;
-	size_t cols;
-	widget_t **layout;
-	void (*add)(grid_t *, widget_t *, size_t, size_t, size_t, size_t);
+	grid_cell_t *layout;
+	bool (*add)(struct grid *, widget_t *, size_t, size_t, size_t, size_t);
 } grid_t;
 
Index: uspace/lib/gui/terminal.c
===================================================================
--- uspace/lib/gui/terminal.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/gui/terminal.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -77,5 +77,5 @@
 static void term_set_rgb_color(con_srv_t *, pixel_t, pixel_t);
 static void term_set_cursor_visibility(con_srv_t *, bool);
-static int term_get_event(con_srv_t *, kbd_event_t *);
+static int term_get_event(con_srv_t *, cons_event_t *);
 
 static con_ops_t con_ops = {
@@ -420,10 +420,11 @@
 		if (pos < size) {
 			link_t *link = prodcons_consume(&term->input_pc);
-			kbd_event_t *event = list_get_instance(link, kbd_event_t, link);
+			cons_event_t *event = list_get_instance(link, cons_event_t, link);
 			
 			/* Accept key presses of printable chars only. */
-			if ((event->type == KEY_PRESS) && (event->c != 0)) {
+			if (event->type == CEV_KEY && event->ev.key.type == KEY_PRESS &&
+			    event->ev.key.c != 0) {
 				wchar_t tmp[2] = {
-					event->c,
+					event->ev.key.c,
 					0
 				};
@@ -579,12 +580,12 @@
 }
 
-static int term_get_event(con_srv_t *srv, kbd_event_t *event)
+static int term_get_event(con_srv_t *srv, cons_event_t *event)
 {
 	terminal_t *term = srv_to_terminal(srv);
 	link_t *link = prodcons_consume(&term->input_pc);
-	kbd_event_t *kevent = list_get_instance(link, kbd_event_t, link);
-	
-	*event = *kevent;
-	free(kevent);
+	cons_event_t *ev = list_get_instance(link, cons_event_t, link);
+	
+	*event = *ev;
+	free(ev);
 	return EOK;
 }
@@ -634,30 +635,48 @@
 }
 
+static void terminal_queue_cons_event(terminal_t *term, cons_event_t *ev)
+{
+	/* Got key press/release event */
+	cons_event_t *event =
+	    (cons_event_t *) malloc(sizeof(cons_event_t));
+	if (event == NULL)
+		return;
+	
+	*event = *ev;
+	link_initialize(&event->link);
+	
+	prodcons_produce(&term->input_pc, &event->link);
+}
+
+/* Got key press/release event */
 static void terminal_handle_keyboard_event(widget_t *widget,
     kbd_event_t kbd_event)
 {
 	terminal_t *term = (terminal_t *) widget;
-	
-	/* Got key press/release event */
-	kbd_event_t *event =
-	    (kbd_event_t *) malloc(sizeof(kbd_event_t));
-	if (event == NULL)
-		return;
-	
-	link_initialize(&event->link);
-	event->type = kbd_event.type;
-	event->key = kbd_event.key;
-	event->mods = kbd_event.mods;
-	event->c = kbd_event.c;
-	
-	prodcons_produce(&term->input_pc, &event->link);
-}
-
-static void terminal_handle_position_event(widget_t *widget, pos_event_t event)
-{
-	/*
-	 * Mouse events are ignored so far.
-	 * There is no consumer for it.
-	 */
+	cons_event_t event;
+	
+	event.type = CEV_KEY;
+	event.ev.key = kbd_event;
+	
+	terminal_queue_cons_event(term, &event);
+}
+
+static void terminal_handle_position_event(widget_t *widget, pos_event_t pos_event)
+{
+	cons_event_t event;
+	terminal_t *term = (terminal_t *) widget;
+	sysarg_t sx = term->widget.hpos;
+	sysarg_t sy = term->widget.vpos;
+
+	if (pos_event.type == POS_PRESS) {
+		event.type = CEV_POS;
+		event.ev.pos.type = pos_event.type;
+		event.ev.pos.pos_id = pos_event.pos_id;
+		event.ev.pos.btn_num = pos_event.btn_num;
+
+		event.ev.pos.hpos = (pos_event.hpos - sx) / FONT_WIDTH;
+		event.ev.pos.vpos = (pos_event.vpos - sy) / FONT_SCANLINES;
+		terminal_queue_cons_event(term, &event);
+	}
 }
 
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/gui/window.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -424,5 +424,7 @@
 
 	while (!list_empty(&win->events.list)) {
-		list_remove(list_first(&win->events.list));
+		window_event_t *event = (window_event_t *) list_first(&win->events.list);
+		list_remove(&event->link);
+		free(event);
 	}
 
Index: uspace/srv/hid/compositor/Makefile
===================================================================
--- uspace/srv/hid/compositor/Makefile	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/hid/compositor/Makefile	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -38,5 +38,4 @@
 
 IMAGES = \
-	gfx/helenos.tga \
 	gfx/nameic.tga
 
